###################################################
### chunk number 1: options
###################################################
#line 23 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
options(prompt=' ')
options(continue=' ')
set.seed(123456)


###################################################
### chunk number 2: redirectmessages eval=FALSE
###################################################
## #line 29 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## options(warn=1,prompt = " ", continue = " ", width = 85)
## cons <- showConnections(all=T)
## .LatexFileName <- "NMF-vignette.tex"
## .LatexFileCon<- getConnection(what = 
## as.integer(rownames(cons)[which(cons[,1]==.LatexFileName)]))
## sink(file = .LatexFileCon, append = TRUE, type = "message" )


###################################################
### chunk number 3: citations eval=FALSE
###################################################
## #line 90 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## citation('NMF')
## # To get the citations in Bibtex:
## toBibtex(citation('NMF'))


###################################################
### chunk number 4: load_library
###################################################
#line 99 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## Install (not run)
# install.packages('NMF')
# Load
library(NMF)


###################################################
### chunk number 5: features
###################################################
#line 118 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nalgo <- length(nmfAlgorithm())
nseed <- length(nmfSeed())


###################################################
### chunk number 6: nmfAlgorithm
###################################################
#line 192 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# list all available algorithms
nmfAlgorithm()
# retrieve a specific algorithm: 'brunet' 
nmfAlgorithm('brunet')
# partial match is also fine
identical(nmfAlgorithm('br'), nmfAlgorithm('brunet')) 


###################################################
### chunk number 7: nmfSeed
###################################################
#line 288 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# list all available seeding methods
nmfSeed()
# retrieve a specific method: 'nndsvd' 
nmfSeed('nndsvd')
# partial match is also fine
identical(nmfSeed('nn'), nmfSeed('nndsvd'))


###################################################
### chunk number 8: show_Rversions
###################################################
#line 366 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmfAlgorithm(all=TRUE)

# to get all the algorithms that have a secondary R version
nmfAlgorithm(type='R')


###################################################
### chunk number 9: perftable_setup
###################################################
#line 379 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# retrieve all the methods that have a secondary R version
meth <- nmfAlgorithm(type='R')
meth <- c(names(meth), meth)
meth

# load the Golub data
data(esGolub)

# compute NMF for each method
res <- nmf(esGolub, 3, meth, seed=123456)

# extract only the elapsed time
t <- sapply(res, runtime)[3,]


###################################################
### chunk number 10: perftable
###################################################
#line 395 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# speed-up
m <- length(meth)/2
su <- cbind( C=t[1:m], R=t[-(1:m)], Speed.up=t[-(1:m)]/t[1:m])

library(xtable)
xtable(su, caption='Performance speed up achieved by the optimized C++ implementation for some of the NMF algorithms.', label='tab:perf')


###################################################
### chunk number 11: esGolub
###################################################
#line 415 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
data(esGolub)
esGolub
esGolub <- esGolub[1:200,]


###################################################
### chunk number 12: algo_default
###################################################
#line 431 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# default NMF algorithm
res <- nmf(esGolub, 3)


###################################################
### chunk number 13: single_show
###################################################
#line 450 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res 


###################################################
### chunk number 14: single_show_model
###################################################
#line 457 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
fit(res)


###################################################
### chunk number 15: single_show_estimate
###################################################
#line 464 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
V.hat <- fitted(res)
dim(V.hat)


###################################################
### chunk number 16: singlerun_summary
###################################################
#line 472 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
summary(res)

# More quality measures are computed, if the target matrix is provided: 
summary(res, target=esGolub)


###################################################
### chunk number 17: singlerun_summary_factor
###################################################
#line 486 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
summary(res, class=esGolub$Cell)


###################################################
### chunk number 18: get_matrices
###################################################
#line 494 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# get matrix W
w <- basis(res)
dim(w)

# get matrix H
h <- coef(res)
dim(h)


###################################################
### chunk number 19: subset
###################################################
#line 508 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# keep only the first 10 features
res.subset <- res[1:10,] 
class(res.subset)
dim(res.subset)
# keep only the first 10 samples 
dim(res[,1:10])
# subset both features and samples:
dim(res[1:20,1:10])


###################################################
### chunk number 20: single_extract
###################################################
#line 531 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# only compute the scores
s <- featureScore(res)
summary(s)

# compute the scores and characterize each metagene
s <- extractFeatures(res)
str(s)


###################################################
### chunk number 21: algo_list
###################################################
#line 550 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmfAlgorithm()


###################################################
### chunk number 22: algo_lee
###################################################
#line 562 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# using Lee and Seung's algorithm
res <- nmf(esGolub, 3, 'lee')
algorithm(res)


###################################################
### chunk number 23: algo_ns
###################################################
#line 569 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# using the Nonsmooth NMF algorithm with parameter theta=0.7
res <- nmf(esGolub, 3, 'ns', theta=0.7)
algorithm(res)
fit(res)


###################################################
### chunk number 24: algo_pe
###################################################
#line 577 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# using the PE-NMF algorithm with parameters alpha=0.01, beta=1
res <- nmf(esGolub, 3, 'pe', alpha=0.01, beta=1)
res


###################################################
### chunk number 25: seed_list
###################################################
#line 616 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmfSeed()


###################################################
### chunk number 26: seed
###################################################
#line 623 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res <- nmf(esGolub, 3, seed='nndsvd')
res


###################################################
### chunk number 27: seed_numeric
###################################################
#line 635 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res <- nmf(esGolub, 3, seed=123456)
res


###################################################
### chunk number 28: seed_WH
###################################################
#line 646 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
n <- nrow(esGolub); p <- ncol(esGolub)
res <- nmf(esGolub, 3, seed=NULL, W=matrix(0.5, n, 3), H=matrix(0.3, 3, p))
res


###################################################
### chunk number 29: seed_model eval=FALSE
###################################################
## #line 659 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## res <- nmf(esGolub, 3, seed=NULL
## 		, model=list(W=matrix(0.5, n, 3), H=matrix(0.3, 3, p)))
## # or
## res <- nmf(esGolub, 3, seed=nmfModel(W=matrix(0.5, n, 3), H=matrix(0.3, 3, p)))


###################################################
### chunk number 30: algo_multirun
###################################################
#line 681 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res.multirun <- nmf(esGolub, 3, nrun=5)
res.multirun


###################################################
### chunk number 31: multirun_keep
###################################################
#line 701 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# explicitly setting the option keep.all to TRUE
res <- nmf(esGolub, 3, nrun=5, .options=list(keep.all=TRUE))
res


###################################################
### chunk number 32: multirun_keep_alt eval=FALSE
###################################################
## #line 707 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## # or using letter code 'k' in argument .options
## nmf(esGolub, 3, nrun=5, .options='k')


###################################################
### chunk number 33: parallel_multicore
###################################################
#line 778 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# the default call will try to run in parallel using all the cores
# => will be in parallel if all the requirements are satisfied
nmf(esGolub, 3, nrun=5, .opt='v')


###################################################
### chunk number 34: parallel_multicore_alt eval=FALSE
###################################################
## #line 784 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## # specifying the number of cores to use 
## nmf(esGolub, 3, nrun=5, .opt='v', .pbackend=2)
## 
## # force parallel computation: use option 'P'
## nmf(esGolub, 3, nrun=5, .opt='vP')


###################################################
### chunk number 35: mpi_file eval=FALSE
###################################################
## #line 803 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## file.show(file.system('examples/mpi.R', package='NMF'))
## 
## # and
## file.show(file.system('examples/mpi_run.sh', package='NMF'))
## 


###################################################
### chunk number 36: mpi eval=FALSE
###################################################
## #line 814 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## 
## ## 0. Create and register an MPI cluster
## library(doMPI)
## cl <- startMPIcluster()
## registerDoMPI(cl)
## library(NMF)
## 
## ## 1. Schedule the runs accross the workers
## nrun <- 100;
## nworker <- getDoParWorkers();
## ntasks <- rep(round(nrun/nworker), nworker)
## # allocate remainder runs
## if( (remain <- nrun %% nworker) > 0 ) 
## 	ntasks[1:remain] <- ntasks[1:remain] + 1
## 
## ## 2. Send the jobs to the workers using a foreach loop
## t <- system.time({
## 	res <- foreach(i=1:getDoParWorkers(), n=ntasks, 
## 		.packages = c('NMF', 'doMC', 'Biobase')) %dopar% {
## 
## 		# each worker run its factorizations in parallel
## 		#Note: only the best result is kept
## 		data(esGolub)
## 		nmf(esGolub, 3, 'brunet', nrun=n, .opt='p')
## 	}
## })
## ## 3. reduce the result and save it in a file
## res <- NMF:::join(res, runtime.all=t)
## save(res, file='result.RData')
## 
## ## 4. Shutdown the cluster and quit MPI
## closeCluster(cl)
## mpi.quit()
## 


###################################################
### chunk number 37: force_seq eval=FALSE
###################################################
## #line 879 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## # force sequential computation by sapply: use option '-p' or .pbackend=''
## nmf(esGolub, 3, nrun=5, .opt='v-p')
## nmf(esGolub, 3, nrun=5, .opt='v', .pbackend='')
## 
## # or use the SEQ backend of foreach: .pbackend=NULL or 'seq'
## nmf(esGolub, 3, nrun=5, .opt='v', .pbackend=NULL)
## nmf(esGolub, 3, nrun=5, .opt='v', .pbackend='seq')


###################################################
### chunk number 38: estimate_rank
###################################################
#line 905 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# perform 10 runs for each value of r in range 2:6
estim.r <- nmfEstimateRank(esGolub, range=2:6, nrun=10, seed=123456)


###################################################
### chunk number 39: estimate_rank_plot
###################################################
#line 916 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
plot(estim.r)


###################################################
### chunk number 40: estimate_rank_plot_include
###################################################
#line 921 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 916 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#921#"
plot(estim.r)
#line 922 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 41: estimate_r_random
###################################################
#line 949 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# shuffle original data
V.random <- randomize(esGolub)
# estimate quality measures from the shuffled data (use default NMF algorithm)
estim.r.random <- nmfEstimateRank(V.random, range=2:6, nrun=10, seed=123456)
# plot measures on same graph
plot(estim.r, ref=estim.r.random)


###################################################
### chunk number 42: estimate_rank_random_include
###################################################
#line 959 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 949 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#959#"
# shuffle original data
V.random <- randomize(esGolub)
# estimate quality measures from the shuffled data (use default NMF algorithm)
estim.r.random <- nmfEstimateRank(V.random, range=2:6, nrun=10, seed=123456)
# plot measures on same graph
plot(estim.r, ref=estim.r.random)
#line 960 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 43: errorplot_compute
###################################################
#line 975 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res <- nmf(esGolub, 3, .options='t')
# or alternatively:
# res <- nmf(esGolub, 3, .options=list(track=TRUE))
plot(res)


###################################################
### chunk number 44: errorplot_include
###################################################
#line 984 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 975 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#984#"
res <- nmf(esGolub, 3, .options='t')
# or alternatively:
# res <- nmf(esGolub, 3, .options=list(track=TRUE))
plot(res)
#line 985 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 45: heatmap_profile
###################################################
#line 1002 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# default is to plot metaprofiles
metaHeatmap(res) 


###################################################
### chunk number 46: heatmap_profile_inc
###################################################
#line 1009 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 1002 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#1009#"
# default is to plot metaprofiles
metaHeatmap(res) 
#line 1010 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 47: heatmap_genes
###################################################
#line 1021 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
metaHeatmap(res, what='features', filter=TRUE)


###################################################
### chunk number 48: heatmap_genes_inc
###################################################
#line 1027 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 1021 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#1027#"
metaHeatmap(res, what='features', filter=TRUE)
#line 1028 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 49: heatmap_consensus
###################################################
#line 1040 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# The cell type is used to label rows and columns 
metaHeatmap(res.multirun, labRow=esGolub$Cell, labCol=esGolub$Cell)


###################################################
### chunk number 50: heatmap_consensus_inc
###################################################
#line 1048 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 1040 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#1048#"
# The cell type is used to label rows and columns 
metaHeatmap(res.multirun, labRow=esGolub$Cell, labCol=esGolub$Cell)
#line 1049 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 51: multimethod
###################################################
#line 1068 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res.multi.method <- nmf(esGolub, 3, list('brunet', 'lee', 'ns'), seed=123456)


###################################################
### chunk number 52: compare
###################################################
#line 1076 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
compare(res.multi.method)

# If prior knowledge of classes is available
compare(res.multi.method, class=esGolub$Cell)


###################################################
### chunk number 53: multiple_errorplot_compute
###################################################
#line 1086 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
res <- nmf(esGolub, 3, list('brunet', 'lee', 'ns'), seed=123456, .options='t')
plot(res)


###################################################
### chunk number 54: multiple_errorplot_include
###################################################
#line 1093 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
#line 1086 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw#from line#1093#"
res <- nmf(esGolub, 3, list('brunet', 'lee', 'ns'), seed=123456, .options='t')
plot(res)
#line 1094 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"


###################################################
### chunk number 55: custom_algo_sig
###################################################
#line 1127 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
my.algorithm <- function(x, seed, param.1, param.2){
	# do something with starting point
	# ...
	
	# return updated starting point
	return(seed)
}


###################################################
### chunk number 56: custom_algo
###################################################
#line 1149 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
my.algorithm <- function(x, seed, scale.factor=1){
	# do something with starting point
	# ...
	# for example: 
	# 1. compute principal components	
	pca <- prcomp(t(x), retx=TRUE)
	
	# 2. use the absolute values of the first PCs for the metagenes
	# Note: the factorization rank is stored in object 'start'	
	factorization.rank <- nbasis(seed)
	metagenes(fit(seed)) <- abs(pca$rotation[,1:factorization.rank])
	# use the rotated matrix to get the mixture coefficient
	# use a scaling factor (just to illustrate the use of extra parameters)
	metaprofiles(fit(seed)) <- t(abs(pca$x[,1:factorization.rank])) / scale.factor
	
	# return updated data
	return(seed)
}


###################################################
### chunk number 57: define_V
###################################################
#line 1174 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
n <- 50; r <- 3; p <- 20
V <-syntheticNMF(n, r, p, noise=TRUE)


###################################################
### chunk number 58: custom_algo_run
###################################################
#line 1179 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmf(V, 3, my.algorithm, scale.factor=10)


###################################################
### chunk number 59: custom_algo_run_obj
###################################################
#line 1190 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# based on Kullbach-Leibler divergence
nmf(V, 3, my.algorithm, scale.factor=10, objective='KL')
# based on custom distance metric
nmf(V, 3, my.algorithm, scale.factor=10
	, objective=function(target, x){ 
			( sum( (target-fitted(x))^4 ) )^{1/4} 
		}
)


###################################################
### chunk number 60: custom_algo_run_mixed
###################################################
#line 1234 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# put some negative input data 
V.neg <- V; V.neg[1,] <- -1;

# this generates an error
err <- try( nmf(V.neg, 3, my.algorithm, scale.factor=10) )
err

# this runs my.algorithm without error
nmf(V.neg, 3, my.algorithm, mixed=TRUE, scale.factor=10)


###################################################
### chunk number 61: nmf_models
###################################################
#line 1257 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmfModel()


###################################################
### chunk number 62: custom_algo_NMFoffset
###################################################
#line 1267 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
my.algorithm.offset <- function(x, seed, scale.factor=1){
	# do something with starting point
	# ...
	# for example: 
	# 1. compute principal components	
	pca <- prcomp(t(x), retx=TRUE)
	
	# retrieve the model being estimated
	data.model <- fit(seed)
	
	# 2. use the absolute values of the first PCs for the metagenes
	# Note: the factorization rank is stored in object 'start'	
	factorization.rank <- nbasis(data.model)
	metagenes(data.model) <- abs(pca$rotation[,1:factorization.rank])	
	# use the rotated matrix to get the mixture coefficient
	# use a scaling factor (just to illustrate the use of extra parameters)
	metaprofiles(data.model) <- t(abs(pca$x[,1:factorization.rank])) / scale.factor
	
	# 3. Compute the offset as the mean expression
	data.model@offset <- rowMeans(x)	
	
	# return updated data
	fit(seed) <- data.model
	seed
}


###################################################
### chunk number 63: custom_algo_NMFOffset_run
###################################################
#line 1296 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
# run custom algorithm with NMF model with offset
nmf(V, 3, my.algorithm.offset, model='NMFOffset', scale.factor=10)


###################################################
### chunk number 64: custom_seed
###################################################
#line 1307 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"

# start: object of class NMF
# target: the target matrix
my.seeding.method <- function(model, target){
	
	# use only the largest columns for W
	w.cols <- apply(target, 2, function(x) sqrt(sum(x^2)))
	metagenes(model) <- target[,order(w.cols)[1:nbasis(model)]]
	
	# initialize H randomly
	metaprofiles(model) <- matrix(runif(nbasis(model)*ncol(target))
						, nbasis(model), ncol(target))

	# return updated object
	return(model)
}


###################################################
### chunk number 65: custom_algo_run
###################################################
#line 1327 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
nmf(V, 3, 'snmf/r', seed=my.seeding.method)


###################################################
### chunk number 66: options_algo eval=FALSE
###################################################
## #line 1339 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## #show default algorithm and seeding method
## nmf.options('default.algorithm', 'default.seed')
## 
## # retrieve a single option
## nmf.getOption('default.seed')
## 
## # All options
## nmf.options()


###################################################
### chunk number 67: sessionInfo
###################################################
#line 1380 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
sessionInfo()


###################################################
### chunk number 68: restaure eval=FALSE
###################################################
## #line 1497 "d:/Rcompile/CRANpkg/local/2.12/NMF/inst/doc/NMF-vignette.Rnw"
## sink(type="message")


